//+------------------------------------------------------------------+
//|                                           r-portfolio-expert.mq4 |
//|                               Copyright  2011, Yury V. Reshetov |
//|                                                  http://bigfx.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, Yury V. Reshetov"
#property link      "http://bigfx.ru"

//---- input parameters
extern double    fraction=0.0;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
  
  
  if (! IsTradeAllowed()) {
   Sleep(30000);
   return(0);
  }
//----
   int total = OrdersTotal();
   
   double lots = 0;
   double lastbuylots = 0;
   double lastselllots = 0;
   
   int buyticket = -1;
   int sellticket = -1;
   
   for (int i = 0; i < total; i++) {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() == Symbol()) {
         if (OrderType() == OP_BUY) {
            lastbuylots = OrderLots();
            lots = lots + OrderLots();
            buyticket = OrderTicket();
         } else {
            lastselllots = OrderLots();
            lots = lots - OrderLots();
            sellticket = OrderTicket();
         }
      }
   }
   
   if ((buyticket >= 0) && (sellticket >= 0)) {
      OrderCloseBy(buyticket, sellticket, Green);
      Sleep(30000);
      return(0);  
   }
   
   double needlots = AccountEquity() * fraction * 0.01 / MarketInfo(Symbol(), MODE_MARGINREQUIRED);
   needlots = needlots - lots;
   needlots = NormalizeDouble(needlots, 2);
   
   if (needlots > 0.0) {
      Comment("   ", Symbol(), "   ", needlots, " ");
      if (sellticket >= 0) {
         if (lastselllots <= needlots) {
            OrderClose(sellticket, lastselllots, Ask, 2, Red);
         } else {
            OrderClose(sellticket, needlots, Ask, 2, Red);
         }
         Sleep(30000);
         return(0);  
      }
      
      if (AccountFreeMargin() < 0.0) {
         Sleep(30000);
         return(0);
      }
      
      if (AccountFreeMargin() > (MarketInfo(Symbol(), MODE_MARGINREQUIRED) * needlots)) {
         OrderSend(Symbol(), OP_BUY, needlots, Ask, 2, 0, 0, WindowExpertName(), 0, 0, Blue);
      } else {
         if (AccountFreeMargin() > (MarketInfo(Symbol(), MODE_MARGINREQUIRED) * 0.1)) {
            OrderSend(Symbol(), OP_BUY, 0.1, Ask, 2, 0, 0, WindowExpertName(), 0, 0, Blue);
         }
      }
      Sleep(30000);
      return(0);  
   }
   if (needlots < 0.0) {
      Comment("   ", Symbol(), "   ", MathAbs(needlots), " ");
      if (buyticket >= 0) {
         if (lastbuylots <= MathAbs(needlots)) {
            OrderClose(buyticket, lastbuylots, Bid, 2, Blue);
         } else {
            OrderClose(buyticket, MathAbs(needlots), Bid, 2, Blue);
         }
         Sleep(30000);
         return(0);  
      }
      
      if (AccountFreeMargin() < 0.0) {
         Sleep(30000);
         return(0);
      }
      
      if (AccountFreeMargin() > (MarketInfo(Symbol(), MODE_MARGINREQUIRED) * MathAbs(needlots))) {
         OrderSend(Symbol(), OP_SELL, MathAbs(needlots), Bid, 2, 0, 0, WindowExpertName(), 0, 0, Red);
      } else {
         if (AccountFreeMargin() > (MarketInfo(Symbol(), MODE_MARGINREQUIRED) * 0.1)) {
            OrderSend(Symbol(), OP_SELL, 0.1, Bid, 2, 0, 0, WindowExpertName(), 0, 0, Red);
         }
      }
      Sleep(30000);
      return(0);  
   }
//----
   return(0);
  }
//+------------------------------------------------------------------+